Project Chrono: chrono::ChShaftsElasticGear Class Reference

Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
chrono::ChShaftsElasticGear Class Reference

## Description

Elastic gear coupling between two shafts.

`#include <ChShaftsLoads.h>`

Inheritance diagram for chrono::ChShaftsElasticGear:
[legend]
Collaboration diagram for chrono::ChShaftsElasticGear:
[legend]

## Public Member Functions
| ChShaftsElasticGear (std::shared_ptr< ChShaft > shaft1, std::shared_ptr< ChShaft > shaft2, const double stiffness, const double damping, const double Ra, const double ratio=-1)
virtual ChShaftsElasticGear * | Clone () const override
| "Virtual" copy constructor (covariant return type).
void | SetTeethStiffness (const double stiffness)
| Set teeth stiffness, at contact point, in tangent direction to the two primitives.
double | GetTeethStiffness () const
void | SetTeethDamping (const double damping)
| Set teeth damping, at contact point, in tangent direction to the two primitives.
double | GetTeethDamping () const
void | SetRestPhase (const double phase)
| Set the phase shaft1-tau*shaft2 for zero compression of the spring (default = 0).
double | GetRestPhase () const
void | SetTransmissionRatioAndRadiusA (double ratio, double Ra)
| Set the transmission ratio t, as in w2=t*w1, or t=w2/w1 , or t*w1 - w2 = 0.
void | SetTransmissionRatioFromRadii (double Ra, double Rb, bool internal=false)
| Set the transmission ratio t, as in w2=t*w1, using the two primitive radii Ra and Rb.
double | GetTransmissionRatio () const
| Get the transmission ratio t, as in w2=t*w1, or t=w2/w1.
double | GetGearRadius1 () const
| Get the primitive radius of the gear wheel of shaft1.
double | GetGearRadius2 () const
| Get the primitive radius of the gear wheel of shaft2.
double | GetContactForce () const
| Get the last computed contact force, for diagnostics.
Public Member Functions inherited from chrono::ChLoadCustomMultiple
| ChLoadCustomMultiple (std::vector< std::shared_ptr< ChLoadable > > &loadable_objects)
| ChLoadCustomMultiple (std::shared_ptr< ChLoadable > loadableA, std::shared_ptr< ChLoadable > loadableB)
| ChLoadCustomMultiple (std::shared_ptr< ChLoadable > loadableA, std::shared_ptr< ChLoadable > loadableB, std::shared_ptr< ChLoadable > loadableC)
virtual int | LoadGetNumCoordsPosLevel () override
| Gets the number of DOFs affected by this load (position part).
virtual int | LoadGetNumCoordsVelLevel () override
| Gets the number of DOFs affected by this load (speed part).
virtual void | LoadGetStateBlock_x (ChState &mD) override
| Gets all the current DOFs packed in a single vector (position part).
virtual void | LoadGetStateBlock_w (ChStateDelta &mD) override
| Gets all the current DOFs packed in a single vector (speed part).
virtual void | LoadStateIncrement (const ChState &x, const ChStateDelta &dw, ChState &x_new) override
| Increment a packed state (e.g., as obtained by LoadGetStateBlock_x()) by a given packed state-delta.
virtual int | LoadGetNumFieldCoords () override
| Number of coordinates in the interpolated field.
virtual void | ComputeJacobian (ChState *state_x, ChStateDelta *state_w) override
| Compute Jacobian matrices K=-dQ/dx, R=-dQ/dv, and M=-dQ/da.
virtual void | LoadIntLoadResidual_F (ChVectorDynamic<> &R, double c) override
| Add the internal loads Q (pasted at global offsets) into a global vector R, multiplied by a scaling factor c.
virtual void | LoadIntLoadResidual_Mv (ChVectorDynamic<> &R, const ChVectorDynamic<> &w, double c) override
| Increment a vector R with the matrix-vector product M*w, scaled by the factor c.
virtual void | LoadIntLoadLumpedMass_Md (ChVectorDynamic<> &Md, double &err, const double c) override
| Add the lumped mass to an Md vector, representing a mass diagonal matrix.
virtual void | CreateJacobianMatrices () override
| Create the Jacobian loads if needed and set the ChVariables referenced by the sparse KRM block.
virtual ChVectorDynamic & | GetQ ()
| Access the generalized load vector Q.
Public Member Functions inherited from chrono::ChLoadBase
ChLoadJacobians * | GetJacobians ()
| Access the Jacobians (if any, i.e. if this is a stiff load).
virtual void | Update (double time)
| Update, called at least at each time step.
virtual void | InjectKRMMatrices (ChSystemDescriptor &descriptor)
| Register with the given system descriptor any ChKRMBlock objects associated with this item.
virtual void | LoadKRMMatrices (double Kfactor, double Rfactor, double Mfactor)
| Compute and load current stiffnes (K), damping (R), and mass (M) matrices in encapsulated ChKRMBlock objects.
Public Member Functions inherited from chrono::ChObj
| ChObj (const ChObj &other)
int | GetIdentifier () const
| Get the unique integer identifier of this object.
void | SetTag (int tag)
| Set an object integer tag (default: -1).
int | GetTag () const
| Get the tag of this object.
void | SetName (const std::string &myname)
| Set the name of this object.
const std::string & | GetName () const
| Get the name of this object.
double | GetChTime () const
| Gets the simulation time of this object.
void | SetChTime (double m_time)
| Sets the simulation time of this object.
virtual void | ArchiveOut (ChArchiveOut &archive_out)
| Method to allow serialization of transient data to archives.
virtual void | ArchiveIn (ChArchiveIn &archive_in)
| Method to allow de-serialization of transient data from archives.
virtual std::string & | ArchiveContainerName ()

## Protected Member Functions
virtual bool | IsStiff () override
| Report if this is load is stiff.
virtual void | ComputeQ (ChState *state_x, ChStateDelta *state_w) override
| Compute Q, the generalized load.
Protected Member Functions inherited from chrono::ChObj
int | GenerateUniqueIdentifier ()

## Protected Attributes
double | m_stiffness
double | m_damping
double | m_rest_phase
double | m_Ra
double | m_ratio
double | m_contact_force
Protected Attributes inherited from chrono::ChLoadBase
ChLoadJacobians * | m_jacobians
Protected Attributes inherited from chrono::ChObj
double | ChTime
| object simulation time
std::string | m_name
| object name
int | m_identifier
| object unique identifier
int | m_tag
| user-supplied tag

## Additional Inherited Members
Public Attributes inherited from chrono::ChLoadCustomMultiple
std::vector< std::shared_ptr< ChLoadable > > | loadables
ChVectorDynamic | load_Q

## Constructor & Destructor Documentation

## ◆ ChShaftsElasticGear()

chrono::ChShaftsElasticGear::ChShaftsElasticGear | ( | std::shared_ptr< ChShaft > | shaft1,
|  | std::shared_ptr< ChShaft > | shaft2,
|  | const double | stiffness,
|  | const double | damping,
|  | const double | Ra,
|  | const double | ratio = -1 )

Parameters

  shaft1 | first shaft
  shaft2 | second shaft
  stiffness | normal stiffness at teeth contact, tangent direction to primitive
  damping | normal damping at teeth contact, tangent direction to primitive
  Ra | primitive radius of the gear on shaft A (the radius of B is not needed)
  ratio | transmission ratio (negative for outer gear, positive for inner gears)

## Member Function Documentation

## ◆ Clone()

virtual ChShaftsElasticGear * chrono::ChShaftsElasticGear::Clone | ( |  | ) | const
| inlineoverridevirtual

"Virtual" copy constructor (covariant return type).

Implements chrono::ChObj.

## ◆ ComputeQ()

void chrono::ChShaftsElasticGear::ComputeQ | ( | ChState * | state_x,
|  | ChStateDelta * | state_w )
| overrideprotectedvirtual

Compute Q, the generalized load.

Called automatically at each Update().

Parameters

  state_x | state position to evaluate Q
  state_w | state speed to evaluate Q

Implements chrono::ChLoadBase.

## ◆ GetContactForce()

double chrono::ChShaftsElasticGear::GetContactForce | ( |  | ) | const
| inline

Get the last computed contact force, for diagnostics.

The force is assumed tangent to the primitives of the gear wheels, it can be positive or negative depending on clock/counterclock effect.

## ◆ IsStiff()

virtual bool chrono::ChShaftsElasticGear::IsStiff | ( |  | ) |
| inlineoverrideprotectedvirtual

Report if this is load is stiff.

If so, InjectKRMMatrices will provide the Jacobians of the load.

Implements chrono::ChLoadBase.

## ◆ SetTransmissionRatioAndRadiusA()

void chrono::ChShaftsElasticGear::SetTransmissionRatioAndRadiusA | ( | double | ratio,
|  | double | Ra )

Set the transmission ratio t, as in w2=t*w1, or t=w2/w1 , or t*w1 - w2 = 0.

For example, t=1 for a rigid joint; t=-0.5 for representing a couple of spur gears with teeth z1=20 & z2=40; t=0.1 for a gear with inner teeth (or epicycloidal reducer), etc. Differently from the ideal ChShaftsGear constraint, this model includes elasticity, so at least the radius of one of the two gear wheels is needed, namely Ra.

## ◆ SetTransmissionRatioFromRadii()

void chrono::ChShaftsElasticGear::SetTransmissionRatioFromRadii | ( | double | Ra,
|  | double | Rb,
|  | bool | internal = false )

Set the transmission ratio t, as in w2=t*w1, using the two primitive radii Ra and Rb.

It will be computed as t=Ra/Rb by default, otherwise t=-Ra/Rb if the bigger wheel has inner teeth.

The documentation for this class was generated from the following files:

- D:/W/B/src/chrono-9.0.1/src/chrono/physics/ChShaftsLoads.h
- D:/W/B/src/chrono-9.0.1/src/chrono/physics/ChShaftsLoads.cpp